> ## Documentation Index
> Fetch the complete documentation index at: https://docs.pnbr.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Review library shape

> Review a library Shape before linking it.

**Operation ID:** `http.shapes.library.review`

```http theme={null}
GET /v1/orgs/{org}/projects/{project}/shapes/library/{publisher}/{shape}/review
```


## OpenAPI

````yaml openapi.json GET /v1/orgs/{org}/projects/{project}/shapes/library/{publisher}/{shape}/review
openapi: 3.1.0
info:
  title: Penumbra API
  version: v1
  description: >-
    HTTP reference for Files, search, extraction, reviews, Graph, Shapes and
    sharing.
servers:
  - url: https://api.pnbr.io
    description: Penumbra API
security: []
paths:
  /v1/orgs/{org}/projects/{project}/shapes/library/{publisher}/{shape}/review:
    get:
      tags:
        - Shapes
      summary: Review library shape
      description: |-
        Review a library Shape before linking it.

        Product guidance: [Shape](/concepts/shape).
      operationId: http.shapes.library.review
      parameters:
        - name: org
          in: path
          required: true
          schema:
            type: string
        - name: project
          in: path
          required: true
          schema:
            type: string
        - name: publisher
          in: path
          required: true
          schema:
            type: string
        - name: shape
          in: path
          required: true
          schema:
            type: string
        - name: artifact_digest
          in: query
          required: true
          description: The listed artifact digest to review, sha256:<64 hex>.
          schema:
            type: string
            pattern: ^sha256:[0-9a-f]{64}$
      responses:
        2XX:
          description: Success.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/http_shapes_library_review_response'
      security:
        - bearerAuth: []
components:
  schemas:
    http_shapes_library_review_response:
      type: object
      properties:
        data:
          type: object
          properties:
            project_id:
              type: string
            publisher:
              type: object
              properties:
                id:
                  type: string
                slug:
                  type: string
                display_name:
                  type: string
              required:
                - id
                - slug
                - display_name
              additionalProperties: {}
            head:
              type: object
              properties:
                shape_id:
                  type: string
                revision_id:
                  type: string
                artifact_digest:
                  type: string
                generation:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
              required:
                - shape_id
                - revision_id
                - artifact_digest
                - generation
              additionalProperties: {}
            status:
              type: string
              enum:
                - ready
                - already_added
                - update_required
                - incompatible
            can_add:
              type: boolean
            current_revision: {}
            candidate_revision: {}
            before:
              type: object
              properties:
                shapes:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                types:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                relationships:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
              required:
                - shapes
                - types
                - relationships
              additionalProperties: false
            after:
              anyOf:
                - type: object
                  properties:
                    shapes:
                      type: integer
                      minimum: -9007199254740991
                      maximum: 9007199254740991
                    types:
                      type: integer
                      minimum: -9007199254740991
                      maximum: 9007199254740991
                    relationships:
                      type: integer
                      minimum: -9007199254740991
                      maximum: 9007199254740991
                  required:
                    - shapes
                    - types
                    - relationships
                  additionalProperties: false
                - type: 'null'
            added_types:
              type: array
              items:
                type: object
                properties:
                  shape_id:
                    type: string
                  type_id:
                    type: string
                  name:
                    type: string
                  description:
                    anyOf:
                      - type: string
                      - type: 'null'
                required:
                  - shape_id
                  - type_id
                  - name
                  - description
                additionalProperties: {}
            added_relationships:
              type: array
              items:
                type: object
                properties:
                  shape_id:
                    type: string
                  relationship_id:
                    type: string
                  name:
                    type: string
                  description:
                    anyOf:
                      - type: string
                      - type: 'null'
                required:
                  - shape_id
                  - relationship_id
                  - name
                additionalProperties: {}
            diagnostics:
              type: array
              items: {}
            existing_data:
              type: string
              const: unchanged
          required:
            - project_id
            - publisher
            - head
            - status
            - can_add
            - current_revision
            - candidate_revision
            - before
            - after
            - added_types
            - added_relationships
            - diagnostics
            - existing_data
          additionalProperties: {}
      required:
        - data
      additionalProperties: false
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.